<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: Moco User Guide</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_user.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For MATLAB, Python, Java, and C++ users</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('mocouserguide.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="PageDoc"><div class="header">
  <div class="headertitle">
<div class="title">Moco User Guide </div>  </div>
</div><!--header-->
<div class="contents">
<div class="toc"><h3>Table of Contents</h3>
<ul><li class="level1"><a href="#gettingstartedsection">Getting started</a></li>
<li class="level1"><a href="#mocotool">MocoTools</a></li>
<li class="level1"><a href="#mocostudysection">Solving custom optimal control problems</a></li>
<li class="level1"><a href="#mocochoosingmodel">Choosing a Model</a></li>
<li class="level1"><a href="#mococustomgoal">Defining a custom goal or cost</a></li>
<li class="level1"><a href="#mocosealed">Sealed solutions or trajectories</a></li>
<li class="level1"><a href="#utilities">Utilities</a></li>
<li class="level1"><a href="#faqsection">Frequently Asked Questions</a></li>
<li class="level1"><a href="#mococheatsheet">Cheat sheet</a></li>
</ul>
</div>
<div class="textblock"><h1><a class="anchor" id="gettingstartedsection"></a>
Getting started</h1>
<p>To learn how to download, install, and run your first Moco example, see the following page:</p><ul>
<li><a class="el" href="mocogettingstarted.html">Getting started with Moco</a></li>
</ul>
<h1><a class="anchor" id="mocotool"></a>
MocoTools</h1>
<p>Moco provides easy-to-use tools for solving for muscle activity that can achieve an observed motion. See the following pages:</p>
<ul>
<li><a class="el" href="mocotrack.html">MocoTrack: kinematics are tracked in the cost</a></li>
<li><a class="el" href="mocoinverse.html">MocoInverse: kinematics are prescribed</a></li>
</ul>
<p>These tools derive from the <a class="el" href="classOpenSim_1_1MocoTool.html" title="This is a base class for solving problems that depend on an observed motion using Moco&#39;s optimal cont...">MocoTool</a> class.</p>
<h1><a class="anchor" id="mocostudysection"></a>
Solving custom optimal control problems</h1>
<p>If the <a class="el" href="classOpenSim_1_1MocoTool.html" title="This is a base class for solving problems that depend on an observed motion using Moco&#39;s optimal cont...">MocoTool</a>s do not satisfy your needs, you can create and solve your own custom optimal control problem using the <a class="el" href="classOpenSim_1_1MocoStudy.html" title="The top-level class for solving a custom optimal control problem.">MocoStudy</a> class.</p>
<p><a class="el" href="mocostudy.html">MocoStudy: custom optimal control problems</a></p>
<h1><a class="anchor" id="mocochoosingmodel"></a>
Choosing a Model</h1>
<p>Moco supports most <a class="el" href="namespaceOpenSim.html" title="The Moco interface is contained within the OpenSim namespace.">OpenSim</a> models, including those with kinematic constraints, auxiliary (muscle) dynamics, and passive force components.</p>
<p>Currently, Moco does not support models with <a class="el" href="classOpenSim_1_1Controller.html" title="Controller is an abstract ModelComponent that defines the interface for   an OpenSim Controller.">Controller</a>s. Moco must serve as the sole controller of the model. This prevents, for example, using reflex controllers to model spasticity. We hope to add support for <a class="el" href="classOpenSim_1_1Model.html" title="A concrete class that specifies the interface to a musculoskeletal model.">Model</a> Controllers in the future.</p>
<p>Moco does not support models with SimTK::Measures, such as <a class="el" href="classOpenSim_1_1Probe.html" title="This class represents a Probe which is designed to query a Vector of model values given system state.">Probe</a>s. Some Measures rely on time-stepping forward integration, which does not occur with Moco. This prevents using, for example, the metabolics probes with Moco.</p>
<p>Some model components are supported through Moco but may hinder the solvers from converging quickly. Any components with discontinuous functions can cause issues for the derivative-based optimization algorithms used by Moco. We suggest replacing your model's muscles with <a class="el" href="classOpenSim_1_1DeGrooteFregly2016Muscle.html" title="This muscle model was published in De Groote et al.">DeGrooteFregly2016Muscle</a>s and replacing your contact forces with <a class="el" href="classOpenSim_1_1SmoothSphereHalfSpaceForce.html" title="This compliant contact force model is similar to HuntCrossleyForce, except that this model applies fo...">SmoothSphereHalfSpaceForce</a>s. These components are designed for use with direct collocation.</p>
<h1><a class="anchor" id="mococustomgoal"></a>
Defining a custom goal or cost</h1>
<p>Moco allows you to compose your cost from multiple existing cost terms. This gives you flexibility and means that you usually do not need to write your cost yourself, even if it has many terms. Moco's existing costs are usually well-tested and work well with Moco's solvers, so we encourage you to use them if possible. In the case that you want to create your own custom cost term, you can derive from <a class="el" href="classOpenSim_1_1MocoGoal.html" title="A goal is a term in the cost functional to be minimized, or a set of endpoint constraints that must l...">MocoGoal</a> in C++. See <a class="el" href="exampleSlidingMassAdvanced_8cpp-example.html">exampleSlidingMassAdvanced.cpp</a> and <a class="el" href="exampleMocoCustomEffortGoal_8cpp-example.html">exampleMocoCustomEffortGoal.cpp</a>.</p>
<p>If you do not want to write C++ code, you can prototype your cost in MATLAB and we can help convert it to C++. See the Matlab example <a class="el" href="examplePrototypeCustomGoal_8m-example.html">examplePrototypeCustomGoal.m</a> for more information.</p>
<p>In the future, Moco could allow you to define custom cost terms in Python. If this is of interest to you, please let the Moco developers know (on GitHub).</p>
<h1><a class="anchor" id="mocosealed"></a>
Sealed solutions or trajectories</h1>
<p>Moco uses the <a class="el" href="classOpenSim_1_1MocoTrajectory.html" title="The values of the variables in an optimal control problem.">MocoTrajectory</a> and <a class="el" href="classOpenSim_1_1MocoSolution.html" title="Return type for MocoStudy::solve().">MocoSolution</a> classes to hold initial guesses and solutions to optimal control problems. Solving a problem (MocoStudy::solve()) returns a <a class="el" href="classOpenSim_1_1MocoSolution.html" title="Return type for MocoStudy::solve().">MocoSolution</a>. If the solver failed to converge, the solution will be sealed (<a class="el" href="classOpenSim_1_1MocoTrajectory.html#abe404d23552fffaf3cfb08cd8f83fb34">MocoTrajectory::isSealed()</a>), which means that you cannot do anything with the it (read, edit, or write) until you call MocoTrajectory::unseal(). The sealing forces you to acknowledge that the solver failed.</p>
<h1><a class="anchor" id="utilities"></a>
Utilities</h1>
<p><a class="el" href="namespaceOpenSim.html" title="The Moco interface is contained within the OpenSim namespace.">OpenSim</a> and Moco contain utilities for creating models, modifying models, working with data, and postprocessing results.</p>
<ol type="1">
<li><a class="el" href="classOpenSim_1_1ModelFactory.html" title="This class provides utilities for creating OpenSim models.">ModelFactory</a>: Create standard models and modify existing models.</li>
<li><a class="el" href="classOpenSim_1_1ModelProcessor.html" title="This class describes a workflow for processing a Model using ModelOperators.">ModelProcessor</a>: Create a workflow of operations to perform on a model.</li>
<li><a class="el" href="classOpenSim_1_1TableProcessor.html" title="This class describes a workflow for processing a table using TableOperators.">TableProcessor</a>: Create a workflow of operations to perform on a table.</li>
<li><a class="el" href="group__mocoutil.html">Moco Utilities</a>, including visualizing and analyzing a <a class="el" href="classOpenSim_1_1MocoTrajectory.html" title="The values of the variables in an optimal control problem.">MocoTrajectory</a>.</li>
<li>plot_trajectory.py: Plot a <a class="el" href="classOpenSim_1_1MocoTrajectory.html" title="The values of the variables in an optimal control problem.">MocoTrajectory</a> with the Python Matplotlib plotting library.</li>
<li>report.py: Generate a detailed PDF report about a <a class="el" href="classOpenSim_1_1MocoTrajectory.html" title="The values of the variables in an optimal control problem.">MocoTrajectory</a> and any reference data (part of the <code>opensim</code> Python package).</li>
</ol>
<h1><a class="anchor" id="faqsection"></a>
Frequently Asked Questions</h1>
<p>See <a class="el" href="mocofaq.html">Moco frequently asked questions</a>.</p>
<h1><a class="anchor" id="mococheatsheet"></a>
Cheat sheet</h1>
<p>This short PDF shows common Moco commands, and makes for a nice desk-side companion.</p>
<p> 
<embed src="MocoCheatSheet.pdf" width="500px" height="600px"></embed>
 </p>
</div></div><!-- contents -->
</div><!-- PageDoc -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="mocomainpage.html">Moco</a></li>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:40 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
